
// sbottalkDlg.cpp : implementation file
//

#include "stdafx.h"
#include "sbottalk.h"
#include "sbottalkDlg.h"
#include "afxdialogex.h"

#include "komunikacia.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CsbottalkDlg dialog




CsbottalkDlg::CsbottalkDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CsbottalkDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	//  m_prikaz = _T("");
	//  m_odpoved = _T("");
}

void CsbottalkDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	//  DDX_Text(pDX, IDC_EDIT1, m_prikaz);
	//  DDX_Text(pDX, IDC_EDIT2, m_odpoved);
	DDX_Control(pDX, IDC_BUTTON1, m_sendmsg);
	DDX_Control(pDX, IDC_EDIT1, m_prikaz);
	DDX_Control(pDX, IDC_EDIT2, m_odpoved);
	DDX_Control(pDX, IDC_EDIT3, m_inputport);
}

BEGIN_MESSAGE_MAP(CsbottalkDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, &CsbottalkDlg::OnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CsbottalkDlg::OnClickedButton2)
END_MESSAGE_MAP()


// CsbottalkDlg message handlers

BOOL CsbottalkDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	m_prikaz.EnableWindow( FALSE );
	m_sendmsg.EnableWindow ( FALSE );

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CsbottalkDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CsbottalkDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CsbottalkDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CsbottalkDlg::OnClickedButton1()
{
	// vezmem si vsetky premenne
	WCHAR msg[255];
	CString povodny_text;
	CString prikaz;
	m_odpoved.GetWindowTextW( povodny_text );
	m_prikaz.GetWindowTextW( prikaz );
	// vypis na obrazovku
	if (povodny_text == "") 
	{
	  m_odpoved.SetWindowTextW( prikaz );
	} else 
	{
	  m_odpoved.SetWindowTextW( povodny_text + "\r\n" + prikaz );
	}
	m_prikaz.SetWindowTextW( 0 ); // vymaze	obsah prikazoveho riadku							

	if (prikaz == "hello") 
	{
		sbot_open(L"\\\\.\\"+inputport+"");
		sbot_hello();
		m_odpoved.SetWindowTextW(msg);
		sbot_close();
	}
	else if (prikaz == "go") 
	{
		sbot_open(L"\\\\.\\"+inputport+"");
		sbot_forward();
		sbot_close();
	}
	else if (prikaz == "left") 
	{
		sbot_open(L"\\\\.\\"+inputport+"");
		sbot_left();
		sbot_close();
	}
	else if (prikaz == "right") 
	{
		sbot_open(L"\\\\.\\"+inputport+"");
		sbot_right();
		sbot_close();
	}
	else if (prikaz == "rotate") 
	{
		sbot_open(L"\\\\.\\"+inputport+"");
		sbot_rotate();
		sbot_close();
	}
	else if (prikaz == "back") 
	{
		sbot_open(L"\\\\.\\"+inputport+"");
		sbot_back();
		sbot_close();
	}
	else if (prikaz == "stop") 
	{
		sbot_open(L"\\\\.\\"+inputport+"");
		sbot_stop();
		sbot_close();
	}
	else if (prikaz == "status") 
	{
		sbot_open(L"\\\\.\\"+inputport+"");
		do {
		  sbot_status *s = sbot_get_status();
		  if (s == 0) break;
		  wsprintf(msg, L"Line senzor: s1=%d, s2=%d\r\nBumper: b0=%d, b1=%d, b2=%d, b3=%d\r\nRetry?", s->s1, s->s2, s->s3, s->s4, s->s5, s->s6);
		  m_odpoved.SetWindowTextW(msg);
		  delete s;
		} while (::MessageBox(0, msg, L"SBOT HOKUS", MB_YESNO) == IDYES);
		sbot_close();
	}
	else 
	{
		m_odpoved.GetWindowTextW( povodny_text );
		m_odpoved.SetWindowTextW( povodny_text + " -> neznmy prkaz" );
	}
	//Sleep(2000); // 2 SEKUNDY
}


void CsbottalkDlg::OnClickedButton2()
{
	// vezmem si nastavenia portov a spristupnim zadavacie policka
	m_inputport.GetWindowTextW( inputport );
	m_prikaz.EnableWindow( TRUE );
	m_sendmsg.EnableWindow ( TRUE );
}